=== debian/changelog ===
openstructure (2.10.0-1~exp) experimental; urgency=medium

  * New upstream version 2.10.0

 -- Andrius Merkys <merkys@debian.org>  Fri, 23 May 2025 03:40:10 -0400
